<?php
if ( ! class_exists( 'Personal_Tutor_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Personal_Tutor_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Personal_Tutor_Plugin_Activation_WPElemento_Importer {

        private static $personal_tutor_instance;
        public $personal_tutor_action_count;
        public $personal_tutor_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$personal_tutor_instance) ) {
            self::$personal_tutor_instance = new self();
          }
          return self::$personal_tutor_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'personal_tutor_recommended_plugins', array($this, 'personal_tutor_recommended_elemento_importer_plugins_array') );

            $personal_tutor_actions                   = $this->personal_tutor_get_recommended_actions();
            $this->personal_tutor_action_count        = $personal_tutor_actions['count'];
            $this->personal_tutor_recommended_actions = $personal_tutor_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function personal_tutor_recommended_elemento_importer_plugins_array($personal_tutor_plugins){
            $personal_tutor_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'personal-tutor'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'personal-tutor'),               
            );
            return $personal_tutor_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'personal-tutor-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('personal-tutor-plugin-activation-script', 'personal_tutor_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'personal-tutor'),
                    'activating' => esc_html__('Activating', 'personal-tutor'),
                    'error' => esc_html__('Error', 'personal-tutor'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'personal-tutor-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function personal_tutor_get_recommended_actions() {

            $personal_tutor_act_count  = 0;
            $personal_tutor_actions_todo = get_option( 'recommending_actions', array());

            $personal_tutor_plugins = $this->personal_tutor_get_recommended_plugins();

            if ($personal_tutor_plugins) {
                foreach ($personal_tutor_plugins as $personal_tutor_key => $personal_tutor_plugin) {
                    $personal_tutor_action = array();
                    if (!isset($personal_tutor_plugin['slug'])) {
                        continue;
                    }

                    $personal_tutor_action['id']   = 'install_' . $personal_tutor_plugin['slug'];
                    $personal_tutor_action['desc'] = '';
                    if (isset($personal_tutor_plugin['desc'])) {
                        $personal_tutor_action['desc'] = $personal_tutor_plugin['desc'];
                    }

                    $personal_tutor_action['name'] = '';
                    if (isset($personal_tutor_plugin['name'])) {
                        $personal_tutor_action['title'] = $personal_tutor_plugin['name'];
                    }

                    $personal_tutor_link_and_is_done  = $this->personal_tutor_get_plugin_buttion($personal_tutor_plugin['slug'], $personal_tutor_plugin['name'], $personal_tutor_plugin['function']);
                    $personal_tutor_action['link']    = $personal_tutor_link_and_is_done['button'];
                    $personal_tutor_action['is_done'] = $personal_tutor_link_and_is_done['done'];
                    if (!$personal_tutor_action['is_done'] && (!isset($personal_tutor_actions_todo[$personal_tutor_action['id']]) || !$personal_tutor_actions_todo[$personal_tutor_action['id']])) {
                        $personal_tutor_act_count++;
                    }
                    $personal_tutor_recommended_actions[] = $personal_tutor_action;
                    $personal_tutor_actions_todo[]        = array('id' => $personal_tutor_action['id'], 'watch' => true);
                }
                return array('count' => $personal_tutor_act_count, 'actions' => $personal_tutor_recommended_actions);
            }

        }

        public function personal_tutor_get_recommended_plugins() {

            $personal_tutor_plugins = apply_filters('personal_tutor_recommended_plugins', array());
            return $personal_tutor_plugins;
        }

        public function personal_tutor_get_plugin_buttion($slug, $name, $function) {
                $personal_tutor_is_done      = false;
                $personal_tutor_button_html  = '';
                $personal_tutor_is_installed = $this->is_plugin_installed($slug);
                $personal_tutor_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $personal_tutor_is_activeted = (class_exists($function)) ? true : false;
                if (!$personal_tutor_is_installed) {
                    $personal_tutor_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $personal_tutor_plugin_install_url = wp_nonce_url($personal_tutor_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $personal_tutor_button_html        = sprintf('<a class="personal-tutor-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($personal_tutor_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'personal-tutor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'personal-tutor')
                    );
                } elseif ($personal_tutor_is_installed && !$personal_tutor_is_activeted) {

                    $personal_tutor_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($personal_tutor_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $personal_tutor_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $personal_tutor_button_html = sprintf('<a class="personal-tutor-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($personal_tutor_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'personal-tutor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'personal-tutor')
                    );
                } elseif ($personal_tutor_is_activeted) {
                    $personal_tutor_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'personal-tutor'));
                    $personal_tutor_is_done     = true;
                }

                return array('done' => $personal_tutor_is_done, 'button' => $personal_tutor_button_html);
            }
        public function is_plugin_installed($slug) {
            $personal_tutor_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $personal_tutor_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($personal_tutor_installed_plugins[$personal_tutor_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $personal_tutor_keys = array_keys($this->get_installed_plugins());
            foreach ($personal_tutor_keys as $personal_tutor_key) {
                if (preg_match('|^' . $slug . '/|', $personal_tutor_key)) {
                    return $personal_tutor_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Personal_Tutor_Plugin_Activation_WPElemento_Importer::get_instance();